package de.hs_mannheim.informatik.pr2projekt.gui;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import de.hs_mannheim.informatik.pr2projekt.domain.HitoriMain;

public class HighscoreGUI {

    public static void highscoreScreen(String[] filepath){
        JFrame frame = new JFrame("Highscores");
        JPanel highscorePanel = new JPanel(new BorderLayout());
        JPanel buttonPanel = new JPanel(new GridLayout(7,1,10,10));
        String[] buttons = {
            "Highscore 4x4 - leicht",
            "Highscore 5x5 - leicht",
            "Highscore 8x8 - leicht",
            "Highscore 8x8 - medium",
            "Highscore 10x10 - medium",
            "Highscore 15x15 - medium"
        };
        for(int i=0;i<buttons.length;i++){
            JButton b0 = new JButton(buttons[i]);
            buttonPanel.add(b0);
            int[] count = {i};
            char rowChar = buttons[i].charAt(0);
            String[] row = {String.valueOf(rowChar)}; 
            b0.addActionListener(e -> {
                int j = count[0];
                String[] paths = {
                    "Hitori_Highscores/Hitori4x4_leicht.txt",
                    "Hitori_Highscores/Hitori5x5leicht.txt",
                    "Hitori_Highscores/Hitori8x8leicht.txt",
                    "Hitori_Highscores/Hitori8x8medium.txt",
                    "Hitori_Highscores/Hitori10x10medium.txt",
                    "Hitori_Highscores/Hitori15x15_medium.txt"
                };
                HighscoreGUI.showHighscores(paths[j]);
                frame.dispose();
            });
        }
        JButton b = new JButton("Zurück");
        b.addActionListener(e -> {
            frame.dispose();
            MenuGUI.getPath(filepath);
        });
        buttonPanel.add(b);
        frame.setVisible(true);
        frame.setSize(600,600);
        highscorePanel.add(buttonPanel, BorderLayout.CENTER);
        JLabel text0 = new JLabel("Level für Highscore Liste auswählen!");
        highscorePanel.add(text0, BorderLayout.NORTH);
        frame.setDefaultCloseOperation(0);
        frame.add(highscorePanel);
    }
    
    public static void newRecord(String path, String username) throws FileNotFoundException{
        String[] parts = path.split("/");
        String filename = parts[parts.length - 1]; 
        int dotIndex = filename.lastIndexOf("."); 
        String result = filename.substring(0, dotIndex); 
        String ordner = "Hitori_Highscores/";
        String filetype = ".txt";
        String filepath = ordner+result+filetype;
        Scanner sc = new Scanner(filepath);
            while (sc.hasNextLine()) {
                sc.nextLine();
            }
            sc.close();
        try (BufferedWriter writer = new BufferedWriter(new FileWriter(filepath, true))) {
            writer.write(username);
            writer.newLine();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    public static void showHighscores(String[] filepath, String path){
        JFrame frame = new JFrame("Highscore");
        JPanel mainPanel = new JPanel(new BorderLayout());
        File file = new File(path);
        int i = 0;
        try (Scanner scanner = new Scanner(file)) {
            while (scanner.hasNextLine()) {
                scanner.nextLine();
                i++;
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        JPanel highscorePanel = new JPanel(new GridLayout(i,1,10,10));
        if(i>0){
            ArrayList<String> lines = HitoriMain.readFromFile(path);
            for(String s: lines){
                JLabel text = new JLabel(s);
                highscorePanel.add(text);
            }
            JButton b = new JButton("Zurück");
            b.addActionListener(e -> {
                frame.dispose();
                highscoreScreen(filepath);
            });
            mainPanel.add(b, BorderLayout.SOUTH);
        } else {
            JLabel text = new JLabel("Noch kein Highscore eingetragen.");
            highscorePanel.add(text);
            JButton b = new JButton("Zurück");
            b.addActionListener(e -> {
                frame.dispose();
                highscoreScreen(filepath);
            });
            mainPanel.add(b, BorderLayout.SOUTH);
        }
        JButton b = new JButton("Zurück");
            b.addActionListener(e ->{
                frame.dispose();
                MenuGUI.getPath(filepath);
            });
        mainPanel.add(highscorePanel, BorderLayout.CENTER);
        frame.add(mainPanel);
        frame.setVisible(true);
        frame.setSize(600,600);
    }

}
